//+------------------------------------------------------------------+
//|   Qualitative Quantitative Estimation Indicator for Metatrader 4 |
//|                                     Copyright  2006Roman Ignatov |
//|                                   mailto:roman.ignatov@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  200 Roman Ignatov"
#property link      "mailto:roman.ignatov@gmail.com"

#property indicator_chart_window

#property indicator_buffers 2
#property indicator_color1 Maroon
#property indicator_color2 Maroon
#property indicator_width1 1
#property indicator_width2 1



extern int SF = 5;

extern int RSI_Period = 14;

extern int RSI_Price = PRICE_CLOSE;

extern int MA_Mode = MODE_EMA;

extern double Fast = 0.5;

extern double dist = 0.5;

// alert

extern bool enableAlerts=false;

extern bool onlySound=true;

extern string soundFile="alert.wav";

int Wilders_Period;
int StartBar;

double TrLevelFast[];
double AtrRsi[];
double MaAtrRsi[];
double Rsi[];
double RsiMa[];
double aup[];
double ado[];
double state[];


int init()
{
    Wilders_Period = RSI_Period * 2 - 1;
    if (Wilders_Period < SF)
        StartBar = SF;
    else
        StartBar = Wilders_Period;
        
    IndicatorBuffers(8);

   SetIndexBuffer(0,aup); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,108);
   SetIndexBuffer(1,ado); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,108);

    SetIndexBuffer(2, RsiMa);
    SetIndexBuffer(3, TrLevelFast);  
    SetIndexBuffer(4, AtrRsi);
    SetIndexBuffer(5, MaAtrRsi);
    SetIndexBuffer(6, Rsi);
    SetIndexBuffer(7, state);
    IndicatorShortName("");
    return(0);
}


int start()
{
    int counted, i;
    double rsi0, rsi1, dar, tr, dv;
    
    if(Bars <= StartBar)
        return (0);

    counted = IndicatorCounted();
    if(counted < 1)
        for(i = Bars - StartBar; i < Bars; i++)
        {
            TrLevelFast[i] = 0.0;
            AtrRsi[i] = 0.0;
            MaAtrRsi[i] = 0.0;
            Rsi[i] = 0.0;
            RsiMa[i] = 0.0;
        }
    
    counted = Bars - counted - 1;
        
    for (i = counted; i >= 0; i--)
        Rsi[i] = iRSI(NULL, 0, RSI_Period, RSI_Price, i);

    for (i = counted; i >= 0; i--)
    {
        RsiMa[i] = iMAOnArray(Rsi, 0, SF, 0, MA_Mode, i);
        AtrRsi[i] = MathAbs(RsiMa[i + 1] - RsiMa[i]);
    }

    for (i = counted; i >= 0; i--)
        MaAtrRsi[i] = iMAOnArray(AtrRsi, 0, Wilders_Period, 0, MA_Mode, i);

    i = counted + 1;
    tr = TrLevelFast[i];
    rsi1 = iMAOnArray(Rsi, 0, SF, 0, MA_Mode, i);
    while (i > 0)
    {
        i--;
        rsi0 = iMAOnArray(Rsi, 0, SF, 0, MA_Mode, i);
        dar = iMAOnArray(MaAtrRsi, 0, Wilders_Period, 0, MA_Mode, i) * Fast;

        dv = tr;
        if (rsi0 < tr)
        {
            tr = rsi0 + dar;
            if (rsi1 < dv)
                if (tr > dv)
                    tr = dv;
        }
        else if (rsi0 > tr)
        {
            tr = rsi0 - dar;
            if (rsi1 > dv)
                if (tr < dv)
                    tr = dv;
        }
        TrLevelFast[i] = tr;
        rsi1 = rsi0;


          {
            aup[i] = EMPTY_VALUE;
            ado[i] = EMPTY_VALUE;

               state[i] = state[i+1];  
                  if (RsiMa[i]>TrLevelFast[i]) state[i] =  1;
                  if (RsiMa[i]<TrLevelFast[i]) state[i] = -1;
                  if (state[i]!=state[i+1])
                  {
                     if (state[i] ==  1) aup[i] = Low[i]-dist*iATR(NULL,0,20,i);
                     if (state[i] == -1) ado[i] = High[i]+dist*iATR(NULL,0,20,i);
                  }
          }
        

    }

         

// tu wstawka z alertem

    if(enableAlerts && isNewBar()) {
    
     if(TrLevelFast[1]>RsiMa[1] && TrLevelFast[2]<RsiMa[2]) {
      if(onlySound) {
       PlaySound(soundFile);
      } else {
       Alert("Cross up on " + Symbol());
      }
     }
     
     if(TrLevelFast[1]<RsiMa[1] && TrLevelFast[2]>RsiMa[2]) {
      if(onlySound) {
       PlaySound(soundFile);
      } else {
       Alert("Cross down on " + Symbol());
      }
     }
         
    }

// koniec wstawki    

    return(0);
}

// wstawka zwiazana z alertem

bool isNewBar() {
 static int prevTime; 
 bool newBar=false; 
 
 if(Time[0]!=prevTime) { 
  newBar=true; 
  prevTime=Time[0]; 
 }
 
 return(newBar);
}

// koniec wstawki